function C2p29_PSET3_13p9

%%
% ********************************************************************
% Course Homework
%               2.29: Numerical Fluid Mechanincs, Spring 2007
% Problem Set #3, Problem #3, Textbook Problem #13.9
% 04/10/07
% ********************************************************************
% Reza Karimi:
%                            Graduate Student
%                    Mechanical Engineering Department
%                  Massachusetts Institute of Technology
% Email:  rkarimi@mit.edu
% Office: NE47-319, 500 Technology Square, Cambridge, MA 02139
% Phone: (617) 324-7605
% ********************************************************************

%%
close all, clc, clear all


n_frmt='%+5.5f'; %fprintf format
er_frmt='%+5.5e';
f=@(x) (-x^4-2*x^3-8*x^2-5*x);
%f=@(x) (x^5-2*x^3+x);
%f=@(x) 2*sin(x)-x^2/10;

%%
xl=-2;xu=1;
%xl=0;xu=1;
r=(5^0.5-1)/2;

d=r*(xu-xl);

fl=f(xl);
fu=f(xu);

xm1=xl+d;xm2=xu-d;
fm1=f(xm1);fm2=f(xm2);
xs=best([xl xm2 xm1 xu],[fl fm2 fm1 fu]);


i=1;
fprintf('\n\t Golden-Section Search for Maximum:');

fprintf('\n\n i \t x_l \t\t x_2 \t\t x_1  \t\t x_u \t\t f_l \t\t f_2 \t\t f_1 \t\t f_u \t\t max(x_rel_error)' )
fprintf('\n----------------------------------------------------------------------------------------------------------------------------------------------------------%')
while (xu-xl)*(1-r)/abs(xs)>0.01

    fprintf(['\n %d \t ' n_frmt '\t ' n_frmt '\t ' n_frmt '\t ' n_frmt '\t '...
        er_frmt '\t ' er_frmt '\t ' er_frmt '\t ' er_frmt '\t ' er_frmt '%%'],i,xl,xm2,xm1,xu,fl,fm2,fm1,fu,abs((xu-xl)*(1-r)/abs(xs))*100)
    i=i+1;

    if fm1>fm2
        xl=xm2;
        fl=fm2;
        xm2=xm1;
        fm2=fm1;
        d=r*(xu-xl);
        xm1=xl+d;
        fm1=f(xm1);
    else
        xu=xm1;
        fu=fm1;
        xm1=xm2;
        fm1=fm2;
        d=r*(xu-xl);
        xm2=xu-d;
        fm2=f(xm2);
    end

    xs=best([xl xm2 xm1 xu],[fl fm2 fm1 fu]);

end
fprintf(['\n %d \t ' n_frmt '\t ' n_frmt '\t ' n_frmt '\t ' n_frmt '\t '...
    er_frmt '\t ' er_frmt '\t ' er_frmt '\t ' er_frmt '\t ' er_frmt '%%'],i,xl,xm2,xm1,xu,fl,fm2,fm1,fu,abs((xm1-xm2)/xs)*100)
fprintf('\n\n Final Solution: f(x=%+20.16f)=%+8.6e with  %d iterations \n ',xs,f(xs),i)
fprintf('\n');

%%
x0=-2;x1=-1;x2=1;
%x0=0;x1=1;x2=4;
f0=f(x0);f1=f(x1);f2=f(x2);

i=1;
fprintf('\n\t Quadratic-Interpolation Search for Maximum:');

fprintf('\n\n i \t x_0 \t\t x_1 \t\t x_2  \t\t x_3 \t\t f_0 \t\t f_1 \t\t f_2 \t\t f_3' )
fprintf('\n-----------------------------------------------------------------------------------------------------------------------------------%')
while i<5

    x3=(f0*(x1^2-x2^2)+f1*(x2^2-x0^2)+f2*(x0^2-x1^2))/2/(f0*(x1-x2)+f1*(x2-x0)+f2*(x0-x1));
    f3=f(x3);
    xs=best([x0 x1 x2 x3],[f0 f1 f2 f3]);
    fprintf(['\n %d \t ' n_frmt '\t ' n_frmt '\t ' n_frmt '\t ' n_frmt '\t '...
        er_frmt '\t ' er_frmt '\t ' er_frmt '\t ' er_frmt '\t ' er_frmt '%%'],i,x0,x1,x2,x3,f0,f1,f2,f3)
    i=i+1;

    if x3<x1 % Very Important
        t=x1;x1=x3;x3=t;
        t=f1;f1=f3;f3=t;
    end

    if f1>f3
        x2=x3;
        f2=f3;
    else
        x0=x1;
        f0=f1;
        x1=x3;
        f1=f3;
    end
end
fprintf('\n\n Final Solution: f(x=%+20.16f)=%+8.6e with  %d iterations \n ',xs,f(xs),i)
fprintf('\n');

    function xs=best(X,F)
        [y,I]=max(F);
        xs=X(I);
    end
end