function C2p29_PSET3_3

%%
% ********************************************************************
% Course Homework
%               2.29: Numerical Fluid Mechanincs, Spring 2007
% Problem Set #3, Problem #3
% 04/10/07
% ********************************************************************
% Reza Karimi:
%                            Graduate Student
%                    Mechanical Engineering Department
%                  Massachusetts Institute of Technology
% Email:  rkarimi@mit.edu
% Office: NE47-319, 500 Technology Square, Cambridge, MA 02139
% Phone: (617) 324-7605
% ********************************************************************

close all, clear all,clc

R=1;
U=1;
d_theta=.05;
LS={'-','--',':','-.','none'};
LM={'+','o','*','.','s'};
CL={'b','r','g','m','k'};

i=0;
for r0=[1.01 1.1 1.5 3]
    i=i+1;
    y=[r0 0 0]';
    theta=pi/2;

        
    [THETA_ODEMATLAB,Y_ODEMATLAB]=ode45(@slope,[pi/2:d_theta:pi-d_theta],y);
    Y=Y_ODEMATLAB';THETA=THETA_ODEMATLAB;
    
    THETA=theta;
    Y=y;
    while y(1)<=10*R && (pi-theta)>d_theta
        [theta,y]=Rngge_Kutta_Step(theta,y);
        Y(:,end+1)=y;
        THETA(end+1)=theta;
    end

    R_exact=Y(1,:);
    theta_exact=pi-asin((R_exact./r0.*(r0^3-R^3)./(R_exact.^3-R^3)).^.5);

    figure(1)
    polar(THETA,Y(1,:),'*'),hold on
    polar(theta_exact,R_exact,'r'),hold on
    
    figure(2)
    subplot(3,1,1)
    plot(THETA,Y(1,:),'Marker',LM{i},'LineStyle',LS{i},'Color',CL{i}),hold on
    subplot(3,1,2)
    plot(THETA,Y(2,:),'Marker',LM{i},'LineStyle',LS{i},'Color',CL{i}),hold on
    subplot(3,1,3)
    plot(THETA,Y(3,:),'Marker',LM{i},'LineStyle',LS{i},'Color',CL{i}),hold on
    
    figure(3)
    [Vr,Vt,ds_dt_min]=velocity(THETA(1),Y(1,1));
    [Vr,Vt,ds_dt_max]=velocity(THETA(end),Y(1,end));
    s_t_fit=spline(Y(3,:),[ds_dt_max Y(2,:) ds_dt_min]);
    D2_s_t_fit=fnder(s_t_fit,2);
    
    plot(THETA,fnval(D2_s_t_fit,Y(3,:)),'Marker',LM{i},'LineStyle',LS{i},'Color',CL{i}), hold on
    plot(theta_exact,a_tangetial(theta_exact,R_exact),'k')
    
end

FN_Size_A=18;FN_Size_T=14;

figure(1)
polar([0:.01:1]*2*pi,ones(size([0:.01:1])),'k')
set(gcf,'PaperType','usLetter','PaperOrientation','portrait','PaperUnits','Centimeters','PaperPosition',[1 1 20 18])
axis([-10 2 0 3.2])
legend('Streamline by ODE Runge-Kutta','Exact solution of Streamline')
set(gca,'fontsize',10)
set(gcf,'PaperType','usLetter','PaperOrientation','portrait','PaperUnits','Centimeters','PaperPosition',[1 1 20 18])
    
figure(3)
set(gca,'fontsize',10),grid on, box on
set(gcf,'PaperType','usLetter','PaperOrientation','portrait','PaperUnits','Centimeters','PaperPosition',[1 1 20 18])
[legend_h]=legend('$\frac{r_0}{R}=1.01, Fit$' ,'$\frac{r_0}{R}=1.01, Exact$','$\frac{r_0}{R}=1.1, Fit$','$\frac{r_0}{R}=1.1, Exact$',....
    '$\frac{r_0}{R}=1.5, Fit$','$\frac{r_0}{R}=1.5, Exact$','$\frac{r_0}{R}=3, Fit$','$\frac{r_0}{R}=3, Exact$','Location','northwest');
set(legend_h,'Interpreter','latex')
title (['Tangential Acceleration: Streamlines of Inviscid Flow Passing an Sphere'],'Interpreter','latex',...
    'fontsize',FN_Size_T,'FontAngle','italic','FontWeight','bold','FontName','Times New Roman')
xlabel('$\theta$','Interpreter','latex','fontsize',FN_Size_A,'FontAngle','italic','FontWeight','bold','FontName','Times New Roman')
ylabel('$\frac{a_tR}{U^2}$','Interpreter','latex','fontsize',FN_Size_A,'FontAngle','italic','FontWeight','bold','FontName','Times New Roman')
set(gcf,'Position',[50 50 [25 20]*30],'color','w')

figure(2)
set(gcf,'PaperType','usLetter','PaperOrientation','portrait','PaperUnits','Centimeters','PaperPosition',[1 1 20 18])
set(gcf,'Position',[50 50 [25 25]*30],'color','w'),set(gca,'fontsize',14)
for j=1:3
    subplot(3,1,j)
    set(gca,'XLim',pi/2*[.95 2.05])
    box on, grid on
    xlabel('$\theta$','Interpreter','latex','fontsize',FN_Size_A,'FontAngle','italic','FontWeight','bold','FontName','Times New Roman')
end
subplot(3,1,1)
ylabel('$\frac{r}{R}$','Interpreter','latex','fontsize',FN_Size_A,'FontAngle','italic','FontWeight','bold','FontName','Times New Roman')
title (['Different Streamlines of Inviscid Flow Passing an Sphere for ' '$\frac{r_0}{R}=$' '\{1.01,1.1,1.5,3\}'],'Interpreter','latex',...
    'fontsize',FN_Size_T,'FontAngle','italic','FontWeight','bold','FontName','Times New Roman')
[legend_h]=legend('$\frac{r_0}{R}=1.01$' ,'$\frac{r_0}{R}=1.1$','$\frac{r_0}{R}=1.5$','$\frac{r_0}{R}=3$','Location','northwest');
set(legend_h,'Interpreter','latex')
subplot(3,1,2)
ylabel('$\frac{s}{R}$','Interpreter','latex','fontsize',FN_Size_A,'FontAngle','italic','FontWeight','bold','FontName','Times New Roman')
subplot(3,1,3)
ylabel('$\frac{tU}{R}$','Interpreter','latex','fontsize',FN_Size_A,'FontAngle','italic','FontWeight','bold','FontName','Times New Roman')

    function [Vr,Vt,V]=velocity(theta,r);
        Vr= U*cos(theta).*(1-   R^3./r.^3);
        Vt=-U*sin(theta).*(1+.5*R^3./r.^3);
        V=(Vr.^2+Vt.^2).^.5;
    end

    function a_t=a_tangetial(theta,r);
        [Vr,Vt,V]=velocity(theta,r);
        a_r    =3/4*(-3*cos(theta).^2*R^3+6*cos(theta).^2.*r.^3-2*r.^3-R^3)*U^2*R^3./r.^7;
        a_theta=3/4*U^2*cos(theta).*sin(theta)*R^3.*(4*r.^3-R^3)./r.^7;
        a_t=(a_r.*Vr+a_theta.*Vt)./V;
    end

    function dy_dt=slope (theta,y)
        r=y(1);
        [Vr,Vt,V]=velocity(theta,r);
        dy_dt=[
            r.*Vr./Vt
            r.*V ./Vt
            r    ./Vt];
    end

    function [theta_n,y_n]=Rngge_Kutta_Step(theta,y)

        k1=slope(theta          ,y             );
        k2=slope(theta+d_theta/2,y+k1*d_theta/2);
        k3=slope(theta+d_theta/2,y+k2*d_theta/2);
        k4=slope(theta+d_theta  ,y+k3*d_theta  );

        theta_n=theta+d_theta;
        y_n=y+(k1+2*k2+2*k3+k4)/6*d_theta;
    end
end